/****
 *
 * Ttulo: Banco de Dados de Alunos
 *
 * Autor:
 *
 * Data de Criao:
 * ltima modificao:
 *
 * Descrio Geral: Este programa mantm um banco de dados de um aluno bl, bl, bl...
 *
 * Entrada: Registros de alunos
 *
 * Sada: Complete!
 *
 ****/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Alunos.h"
#include "Interface.h"
#include "Operacoes.h"

int main(int argc, char** argv)
{
   tTurma   umaTurma = NULL;
   char     oArquivo[TAM_MAX_NOME_ARQ+1] = "";
   unsigned dirty = 0; /* informa se houve mundanas na turma */
   char    	opcao;

   if (argc > 2) {   /* Informe ao usurio como ele deve usar o programa e aborte-o */
      printf("Erro: o programa deve ser usado assim...");
      return EXIT_FAILURE;
   }

   if (argc == 2)
      if (!ValidaNomeDeArquivo(argv[1])) {
         printf("Erro: nome de arquivo invalido.");
         return EXIT_FAILURE;
      } else {
         strcpy(oArquivo, argv[1]);
         if (!(umaTurma = LeTurma(oArquivo))) {
            printf("Erro lendo arquivo");
            return EXIT_FAILURE;
         }
      }
   else
      oArquivo[0] = '\0';

   Apresenta();

   do {
      Menu();
      opcao = LeOpcao();

      switch(opcao) {
         case 'A':
            if (!AcrescentaAluno(&umaTurma))
               printf("\nErro: Nao foi possivel acrescentar registro");
            else
               dirty = 1; /* Ocorreu uma mudana */
            break;
         case 'R':
            if (!RemoveAluno(&umaTurma))
               printf("\nErro: Nao foi possivel remover registro");
            else
               dirty = 1; /* Ocorreu uma mudana */
            break;
         case 'M':
            if (!ModificaRegistro(umaTurma))
               printf("\nErro: Nao foi possivel modificar registro");
            else
               dirty = 1; /* Ocorreu uma mudana */
            break;
         case 'E':
            if (!Enumera(umaTurma))
               printf("\nErro: Nao foi possivel enumerar a turma");
            break;
         case 'L':
            if (dirty) {   /* Houve modificao */
               if (SalvaAlteracao())   /* Usurio quer salvar alteraes */
                  if (!GravaTurma(oArquivo, umaTurma)) { /* Coitado do usurio */
                     printf("Nao foi possivel salvar as alteracoes.");
                     return EXIT_FAILURE;
                  }
               if (umaTurma)
                  LiberaTurma(&umaTurma);
               dirty = 0;
               oArquivo[0] = '\0';
               if (!(umaTurma = LeTurma(oArquivo))) {
                  printf("Erro lendo arquivo");
                  return EXIT_FAILURE;
               }
            }
            break;
         case 'G':
            if (dirty) {
               if (SalvaAlteracao())
                  if (!GravaTurma(oArquivo, umaTurma)) {
                     printf("Sorry. Nao foi possivel salvar as alteracoes.");
                     return EXIT_FAILURE;
                  }
               dirty = 0;
            }
            break;
         case 'S':
            Despedida();
            return 0;
         default:
            printf("Opcao errada.");
      }   /* switch */
   } while (opcao != 'S');

   return EXIT_SUCCESS;
}
